<?php

namespace App\Services\Equipment;

use App\Helpers\Equipment\CSHelper;
use App\Models\Equipment\CSModel;
use App\Services\Customer\ClientService;
use App\Services\Customer\ServiceService;

class CSService extends EquipmentService
{
    private ?ClientService $_clientService = null;
    private ?ServiceService $_serviceService = null;
    private ?ServerService $_serverService = null;
    public function __construct()
    {
        parent::__construct(new CSModel(), new CSHelper());
        $this->addClassName('CS');
    }
    public function getFormFields(): array
    {
        return  [
            "serverinfo_uid",
            "type",
            "ip",
            "accountid",
            "domain",
            "price",
            "status",
        ];
    }
    public function getFormFilters(): array
    {
        return [
            "clientinfo_uid",
            'serverinfo_uid',
            'type',
            'status'
        ];
    }
    public function getIndexFields(): array
    {
        return [
            "clientinfo_uid",
            'serverinfo_uid',
            'type',
            'ip',
            'accountid',
            'domain',
            'price',
            'status',
        ];
    }
    public function getBatchjobFields(): array
    {
        return ['type', 'status'];
    }
    final public function getClientService(): ClientService
    {
        if (!$this->_clientService) {
            $this->_clientService = new ClientService();
        }
        return $this->_clientService;
    }
    public function getServiceService(): ServiceService
    {
        if (!$this->_serviceService) {
            $this->_serviceService = new ServiceService();
        }
        return $this->_serviceService;
    }
    public function getServerService(): ServerService
    {
        if (!$this->_serverService) {
            $this->_serverService = new ServerService();
        }
        return $this->_serverService;
    }
    //기본 기능부분
    //FieldForm관련용
    public function getFormOption(string $field, $options = []): array
    {
        switch ($field) {
            case 'serviceinfo_uid':
                $options = $this->getServiceService()->getEntities();
                break;
            case 'serverinfo_uid':
                $options = $this->getServerService()->getEntities();
                break;
            default:
                $options = parent::getFormOption($field, $options);
                break;
        }
        return $options;
    }
    //List 검색용
    //OrderBy 처리
    public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->getModel()->orderBy('INET_ATON(ip)', 'ASC');
        parent::setOrderBy($field, $value);
    }
}
